table! {
    implementation_wrappers (implementation_wrapper_id) {
        implementation_wrapper_id -> Int4,
        implementation_id -> Int4,
        identifier -> Text,
        label -> Text,
        code -> Text,
        ordering -> Int4,
        is_formatter -> Bool,
        is_asm -> Bool,
    }
}

table! {
    implementations (implementation_id) {
        implementation_id -> Int4,
        identifier -> Text,
        label -> Text,
        ordering -> Int4,
    }
}

table! {
    pastes (paste_id) {
        paste_id -> Int4,
        identifier -> Text,
        delete_at -> Nullable<Timestamptz>,
        created_at -> Timestamptz,
        paste -> Text,
    }
}

joinable!(implementation_wrappers -> implementations (implementation_id));

allow_tables_to_appear_in_same_query!(implementation_wrappers, implementations, pastes,);
